#
# Conditional build:
%bcond_without	python2	# Python 2.x version (available as 'py2lint')
%bcond_with	python3	# Python 3.x version (available as 'py3lint'; built from pylint.spec)
%bcond_without	doc	# Sphinx documentation

Summary:	Python 2 tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Narzędzie Pythona 2 sprawdzające zgodność modułu ze standardem kodowania
Name:		python-pylint
# keep 1.x here for python2 support
Version:	1.9.5
Release:	3
Epoch:		1
License:	GPL v2+
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/simple/pylint
Source0:	https://github.com/PyCQA/pylint/archive/pylint-%{version}.tar.gz
# Source0-md5:	3db0fde1876d50ad313fd707ecd6562b
Patch0:		%{name}-rc.patch
URL:		https://www.pylint.org/
%if %{with python2}
BuildRequires:	python-devel >= 1:2.7
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-pytest-runner
BuildRequires:	python-setuptools >= 1:7.0
%if %{with tests}
BuildRequires:	python-astroid >= 1.6.0
BuildRequires:	python-backports.functools_lru_cache
BuildRequires:	python-configparser
BuildRequires:	python-isort >= 4.2.5
BuildRequires:	python-mccabe
BuildRequires:	python-pytest
BuildRequires:	python-pytest-xdist
BuildRequires:	python-singledispatch
BuildRequires:	python-six
%endif
%endif
%if %{with python3}
BuildRequires:	python3-devel >= 1:3.4
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-pytest-runner
BuildRequires:	python3-setuptools >= 1:7.0
%if %{with tests}
BuildRequires:	python3-astroid >= 1.6.0
BuildRequires:	python3-isort >= 4.2.5
BuildRequires:	python3-mccabe
BuildRequires:	python3-pytest
BuildRequires:	python3-pytest-xdist
BuildRequires:	python3-six
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python-astroid >= 1.6.0
BuildRequires:	python-backports.functools_lru_cache
BuildRequires:	python-configparser
BuildRequires:	python-isort >= 4.2.5
BuildRequires:	python-mccabe
BuildRequires:	python-singledispatch
BuildRequires:	python-six
BuildRequires:	sphinx-pdg-2 >= 1
%endif
Suggests:	python-devel-src
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Python 2 tool that checks if a module satisfy a coding standard.

This package contains only the Python modules used by the tool.

%description -l pl.UTF-8
Narzędzie Pythona 2 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Ten pakiet zawiera tylko moduły Pythona używane przez to narzędzie.

%package -n py2lint
Summary:	Python 2 tool that checks if a module satisfy a coding standard (modules)
Summary(pl.UTF-8):	Narzędzie Pythona sprawdzające zgodność modułu ze standardem kodowania (moduły)
Group:		Libraries/Python
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description -n py2lint
Python 2 tool that checks if a module satisfy a coding standard.

%description -n py2lint -l pl.UTF-8
Narzędzie Pythona 2 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

%package -n python3-pylint
Summary:	Python 3 tool that checks if a module satisfy a coding standard (moduły)
Summary(pl.UTF-8):	Narzędzie Pythona 3 sprawdzające zgodność modułu ze standardem kodowania (modules)
Group:		Libraries/Python

%description -n python3-pylint
Python 3 tool that checks if a module satisfy a coding standard.

This package contains only the Python modules used by the tool.

%description -n python3-pylint -l pl.UTF-8
Narzędzie Pythona 3 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Ten pakiet zawiera tylko moduły Pythona używane przez to narzędzie.

%package -n py3lint
Summary:	Python 3 tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Narzędzie Pythona 3 sprawdzające zgodność modułu ze standardem kodowania
Group:		Development/Languages/Python
Requires:	python3-pylint = %{epoch}:%{version}-%{release}
Obsoletes:	pylint-python3 < 1.0.0-2

%description -n py3lint
Python 3 tool that checks if a module satisfy a coding standard.

Python 3.x version, available via the 'py3lint' command.

%description -n py3lint -l pl.UTF-8
Narzędzie Pythona 3 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Wersja dla Pythona 3.x, dostępna przez polecenie 'py3lint'.

%package doc
Summary:	Documentation for pylint module and tool
Summary(pl.UTF-8):	Dokumentacja do modułu i narzędzia pylint
Group:		Documentation

%description doc
Documentation for pylint module and tool.

%description doc -l pl.UTF-8
Dokumentacja do modułu i narzędzia pylint.

%prep
%setup -q -n pylint-pylint-%{version}
%patch -P 0 -p1

%build
%if %{with python2}
%py_build
%endif

%if %{with python3}
%py3_build
%endif

%if %{with doc}
%{__make} -C doc text \
	PYTHONPATH=$PWD \
	SPHINXBUILD=sphinx-build-2
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_mandir}/man1}

%if %{with python2}
%py_install
%py_postclean

for tool in epylint pylint pyreverse symilar ; do
	%{__mv} $RPM_BUILD_ROOT%{_bindir}/${tool} $RPM_BUILD_ROOT%{_bindir}/${tool}-2
	cp -p man/${tool}.1 $RPM_BUILD_ROOT%{_mandir}/man1/${tool}-2.1
done

cp -p examples/pylintrc $RPM_BUILD_ROOT%{_sysconfdir}/pylintrc-2

# don't package unit test data
%{__rm} -r $RPM_BUILD_ROOT%{py_sitescriptdir}/pylint/test
%endif

%if %{with python3}
%py3_install

for tool in epylint pylint pyreverse symilar ; do
	%{__mv} $RPM_BUILD_ROOT%{_bindir}/${tool} $RPM_BUILD_ROOT%{_bindir}/${tool}-3
	cp -p man/${tool}.1 $RPM_BUILD_ROOT%{_mandir}/man1/${tool}-3.1
done
# old PLD package compatibility
ln -s epylint-3 $RPM_BUILD_ROOT%{_bindir}/epy3lint
ln -s pylint-3 $RPM_BUILD_ROOT%{_bindir}/py3lint
ln -s pyreverse-3 $RPM_BUILD_ROOT%{_bindir}/py3reverse
echo '.so epylint-3.1' >$RPM_BUILD_ROOT%{_mandir}/man1/epy3lint.1
echo '.so pylint-3.1' >$RPM_BUILD_ROOT%{_mandir}/man1/py3lint.1
echo '.so pyreverse-3.1' >$RPM_BUILD_ROOT%{_mandir}/man1/py3reverse.1

cp -p examples/pylintrc $RPM_BUILD_ROOT%{_sysconfdir}/pylintrc-3

# don't package unit test data
%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/pylint/test
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc ChangeLog README.rst examples
%{py_sitescriptdir}/pylint
%{py_sitescriptdir}/pylint-%{version}-py*.egg-info

%files -n py2lint
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/epylint-2
%attr(755,root,root) %{_bindir}/pylint-2
%attr(755,root,root) %{_bindir}/pyreverse-2
%attr(755,root,root) %{_bindir}/symilar-2
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc-2
%{_mandir}/man1/epylint-2.1*
%{_mandir}/man1/pylint-2.1*
%{_mandir}/man1/pyreverse-2.1*
%{_mandir}/man1/symilar-2.1*
%endif

%if %{with python3}
%files -n python3-pylint
%defattr(644,root,root,755)
%doc ChangeLog README.rst examples
%{py3_sitescriptdir}/pylint
%{py3_sitescriptdir}/pylint-%{version}-py*.egg-info

%files -n py3lint
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/epylint-3
%attr(755,root,root) %{_bindir}/pylint-3
%attr(755,root,root) %{_bindir}/pyreverse-3
%attr(755,root,root) %{_bindir}/symilar-3
%attr(755,root,root) %{_bindir}/epy3lint
%attr(755,root,root) %{_bindir}/py3lint
%attr(755,root,root) %{_bindir}/py3reverse
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc-3
%{_mandir}/man1/epylint-3.1*
%{_mandir}/man1/pylint-3.1*
%{_mandir}/man1/pyreverse-3.1*
%{_mandir}/man1/symilar-3.1*
%{_mandir}/man1/epy3lint.1*
%{_mandir}/man1/py3lint.1*
%{_mandir}/man1/py3reverse.1*
%endif

%if %{with doc}
%files doc
%defattr(644,root,root,755)
%doc doc/_build/text/*
%endif
%changelog
* Sun Mar 16 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-pylint.git;a=log;h=master

* Sun Mar 16 2025 Jan Rękorajski <baggins@pld-linux.org> b4fd631
- Release 3 (by relup.sh)

* Sun Mar 16 2025 Jan Rękorajski <baggins@pld-linux.org> 3483714
- use patch -P

* Mon Mar 21 2022 Jakub Bogusz <qboosh@pld-linux.org> fe336af
- BR python-six, switched docs to python2, so python3 is not involved here

* Thu Dec 16 2021 Jakub Bogusz <qboosh@pld-linux.org> 4b67dc9
- setuptools epoch

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> 597c0ac
- release 2 (by relup.sh)

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> 0a71419
- don't package unit test data

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> 7408b9b
- remove conflicting BRs

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> beee75f
- fix docs build

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> 3b475c6
- fix unclosed %if

* Sat Nov 16 2019 Jakub Bogusz <qboosh@pld-linux.org> e74abaa
- epoch 1 (to upgrade from non-functional python-pylint 2.x in Th)

* Sat Nov 16 2019 Jakub Bogusz <qboosh@pld-linux.org> e541e8c
- updated to 1.9.5
- added rc patch use python version specific rc file

* Sat Nov 16 2019 Jakub Bogusz <qboosh@pld-linux.org> 490798a
- reverted to 1.x for python 2

* Sun Nov 03 2019 Jan Rękorajski <baggins@pld-linux.org> a6607fb
- updated BRs
- rel 3

* Mon Oct 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 9101e20
- updated dependencies; now requires python 3.5+ (separate spec with pylint 1.9.x for python2 pending)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> e1a36fc
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Oct 20 2019 Adam Gołębiowski <adamg@pld-linux.org> b0e6a31
- updated to 2.4.3

* Mon Sep 30 2019 Adam Gołębiowski <adamg@pld-linux.org> c35cc74
- updated to 2.4.2

* Sat Sep 28 2019 Adam Gołębiowski <adamg@pld-linux.org> 27c1271
- updated to 2.4.1

* Thu Feb 28 2019 Adam Gołębiowski <adamg@pld-linux.org> 0f8320e
- updated to 2.3.0

* Thu Nov 29 2018 Adam Gołębiowski <adamg@pld-linux.org> 995aa40
- updated to 2.2.2

